Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4520)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4521)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -197,5 +200,5 @@
                 surf_bulk_cloud_model,                                         &
                 surf_microphysics_morrison, surf_microphysics_seifert,         &
-                surf_microphysics_ice_extension,                               &
+                surf_microphysics_ice_phase,                               &
                 surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
                 surf_usm_v
@@ -220,5 +223,5 @@
 
     LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.      !< namelist parameter
-    LOGICAL ::  microphysics_ice_extension = .FALSE.              !< use ice microphysics scheme
+    LOGICAL ::  microphysics_ice_phase = .FALSE.              !< use ice microphysics scheme
     LOGICAL ::  microphysics_sat_adjust = .FALSE.                !< use saturation adjust bulk scheme?
     LOGICAL ::  microphysics_kessler = .FALSE.                   !< use kessler bulk scheme?
@@ -325,5 +328,5 @@
            microphysics_sat_adjust, &
            microphysics_seifert, &
-           microphysics_ice_extension, &
+           microphysics_ice_phase, &
            na_init, &
            nc_const, &
@@ -454,5 +457,5 @@
           ventilation_effect, &
           ice_crystal_sedimentation, &
-          microphysics_ice_extension, &
+          microphysics_ice_phase, &
           start_ice_microphysics, &
           in_init
@@ -582,5 +585,5 @@
        surf_microphysics_morrison = microphysics_morrison
        surf_microphysics_seifert = microphysics_seifert
-       surf_microphysics_ice_extension = microphysics_ice_extension
+       surf_microphysics_ice_phase = microphysics_ice_phase
 !
 !--    Check aerosol
@@ -629,8 +632,8 @@
 
           CASE ( 'ni' )
-             IF ( .NOT.  microphysics_ice_extension )  THEN
+             IF ( .NOT.  microphysics_ice_phase )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" ' //       &
                                  'requires ' //                                &
-                                 'microphysics_ice_extension = ".TRUE."'
+                                 'microphysics_ice_phase = ".TRUE."'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
              ENDIF
@@ -659,8 +662,8 @@
 
           CASE ( 'qi' )
-             IF ( .NOT.  microphysics_ice_extension ) THEN
+             IF ( .NOT.  microphysics_ice_phase ) THEN
                 message_string = 'output of "' // TRIM( var ) // '" ' //       &
                                  'requires ' //                                &
-                                 'microphysics_ice_extension = ".TRUE."'
+                                 'microphysics_ice_phase = ".TRUE."'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
              ENDIF
@@ -758,9 +761,9 @@
 
           CASE ( 'ni' )
-             IF ( .NOT.  microphysics_ice_extension )  THEN
+             IF ( .NOT.  microphysics_ice_phase )  THEN
                 message_string = 'data_output_pr = ' //                        &
                                  TRIM( data_output_pr(var_count) ) //          &
                                  ' is not implemented for' //                  &
-                                 ' microphysics_ice_extension = ".F."'
+                                 ' microphysics_ice_phase = ".F."'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -807,9 +810,9 @@
 
           CASE ( 'qi' )
-             IF ( .NOT.  microphysics_ice_extension )  THEN
+             IF ( .NOT.  microphysics_ice_phase )  THEN
                 message_string = 'data_output_pr = ' //                        &
                                  TRIM( data_output_pr(var_count) ) //          &
                                  ' is not implemented for' //                  &
-                                 ' microphysics_ice_extension = ".F."'
+                                 ' microphysics_ice_phase = ".F."'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -894,5 +897,5 @@
        ENDIF
 
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
 !
 !--       3D-cloud drop water content, cloud drop concentration arrays
@@ -918,5 +921,5 @@
              sums_wsnrs_ws_l = 0.0_wp
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              ALLOCATE( sums_wsqis_ws_l(nzb:nzt+1,0:threads_per_task-1) )
              ALLOCATE( sums_wsnis_ws_l(nzb:nzt+1,0:threads_per_task-1) )
@@ -953,5 +956,5 @@
                           diss_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
              ENDIF
-             IF ( microphysics_ice_extension )  THEN
+             IF ( microphysics_ice_phase )  THEN
                 ALLOCATE( flux_s_qi(nzb+1:nzt,0:threads_per_task-1),           &
                           diss_s_qi(nzb+1:nzt,0:threads_per_task-1),           &
@@ -980,5 +983,5 @@
           nr => nr_1;  nr_p  => nr_2;  tnr_m  => nr_3
        ENDIF
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
           qi => qi_1;  qi_p  => qi_2;  tqi_m  => qi_3
           ni => ni_1;  ni_p  => ni_2;  tni_m  => ni_3
@@ -1027,5 +1030,5 @@
 !
 !--          Initialize the remaining quantities
-             IF ( microphysics_ice_extension )  THEN
+             IF ( microphysics_ice_phase )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -1056,5 +1059,5 @@
                 nr_p  = nr
              ENDIF
-             IF ( microphysics_ice_extension )  THEN
+             IF ( microphysics_ice_phase )  THEN
                 tqi_m = 0.0_wp
                 tni_m = 0.0_wp
@@ -1203,5 +1206,5 @@
                 sums_wsnrs_ws_l = 0.0_wp
              ENDIF
-             IF ( microphysics_ice_extension )  THEN
+             IF ( microphysics_ice_phase )  THEN
                 sums_wsqis_ws_l = 0.0_wp
                 sums_wsnis_ws_l = 0.0_wp
@@ -1247,5 +1250,5 @@
                 sums_wsnrs_ws_l = 0.0_wp
              ENDIF
-             IF ( microphysics_ice_extension )  THEN
+             IF ( microphysics_ice_phase )  THEN
                 sums_wsqis_ws_l = 0.0_wp
                 sums_wsnis_ws_l = 0.0_wp
@@ -1319,7 +1322,7 @@
           ELSEIF ( microphysics_seifert  .AND.  .NOT. microphysics_morrison )  THEN
              CALL adjust_cloud
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_nucleation
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_deposition
              CALL autoconversion
@@ -1329,7 +1332,7 @@
              CALL sedimentation_rain
              IF ( cloud_water_sedimentation )  CALL sedimentation_cloud
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL adjust_ice
-             IF ( ice_crystal_sedimentation .AND. microphysics_ice_extension &
+             IF ( ice_crystal_sedimentation .AND. microphysics_ice_phase &
                   .AND. simulated_time > start_ice_microphysics ) CALL sedimentation_ice
 
@@ -1340,9 +1343,9 @@
              CALL activation
              CALL condensation
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL adjust_ice
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_nucleation
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_deposition
              IF ( cloud_water_sedimentation )  CALL sedimentation_cloud
@@ -1355,9 +1358,9 @@
              CALL activation
              CALL condensation
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL adjust_ice
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_nucleation
-             IF ( microphysics_ice_extension  .AND.  simulated_time > start_ice_microphysics )     &
+             IF ( microphysics_ice_phase  .AND.  simulated_time > start_ice_microphysics )     &
              CALL ice_deposition
              CALL autoconversion
@@ -1434,7 +1437,7 @@
           ELSEIF ( microphysics_seifert  .AND.  .NOT. microphysics_morrison )  THEN
              CALL adjust_cloud_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_nucleation_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_deposition_ij( i,j )
              CALL autoconversion_ij( i,j )
@@ -1444,7 +1447,7 @@
              CALL sedimentation_rain_ij( i,j )
              IF ( cloud_water_sedimentation )  CALL sedimentation_cloud_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL adjust_ice_ij ( i,j )
-             IF ( ice_crystal_sedimentation .AND. microphysics_ice_extension &
+             IF ( ice_crystal_sedimentation .AND. microphysics_ice_phase &
                   .AND. simulated_time > start_ice_microphysics )  CALL sedimentation_ice_ij ( i,j )
 !
@@ -1454,9 +1457,9 @@
              CALL activation_ij( i,j )
              CALL condensation_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL adjust_ice_ij ( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_nucleation_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_deposition_ij( i,j )
              IF ( cloud_water_sedimentation )  CALL sedimentation_cloud_ij( i,j )
@@ -1469,9 +1472,9 @@
              CALL activation_ij( i,j )
              CALL condensation_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL adjust_ice_ij ( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_nucleation_ij( i,j )
-             IF ( microphysics_ice_extension .AND. simulated_time > start_ice_microphysics )       &
+             IF ( microphysics_ice_phase .AND. simulated_time > start_ice_microphysics )       &
                  CALL ice_deposition_ij( i,j )
              CALL autoconversion_ij( i,j )
@@ -1514,5 +1517,5 @@
              CALL exchange_horiz( nr, nbgp )
           ENDIF
-          IF ( microphysics_ice_extension ) THEN
+          IF ( microphysics_ice_phase ) THEN
              CALL exchange_horiz( qi, nbgp )
              CALL exchange_horiz( ni, nbgp )
@@ -1736,5 +1739,5 @@
 !--    If required, calculate prognostic equations for ice crystal content
 !--    and ice crystal concentration
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
 
           CALL cpu_log( log_point(70), 'qi-equation', 'start' )
@@ -2262,5 +2265,5 @@
 !--    If required, calculate prognostic equations for ice crystal mixing ratio
 !--    and ice crystal concentration
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
 !
 !--       Calculate prognostic equation for ice crystal mixing ratio
@@ -2537,5 +2540,5 @@
                    nr => nr_1;    nr_p => nr_2
                 ENDIF
-                IF ( microphysics_ice_extension )  THEN
+                IF ( microphysics_ice_phase )  THEN
                    qi => qi_1;    qi_p => qi_2
                    ni => ni_1;    ni_p => ni_2
@@ -2552,5 +2555,5 @@
                    nr => nr_2;    nr_p => nr_1
                 ENDIF
-                IF ( microphysics_ice_extension )  THEN
+                IF ( microphysics_ice_phase )  THEN
                    qi => qi_2;    qi_p => qi_1
                    ni => ni_2;    ni_p => ni_1
@@ -2601,5 +2604,5 @@
        ENDIF
 
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
 !
 !--       Surface conditions ice crysral (Dirichlet)
@@ -2661,5 +2664,5 @@
              nr_p(:,nys-1,:) = nr_p(:,nys,:)
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              qi_p(:,nys-1,:) = qi_p(:,nys,:)
              ni_p(:,nys-1,:) = ni_p(:,nys,:)
@@ -2674,5 +2677,5 @@
              nr_p(:,nyn+1,:) = nr_p(:,nyn,:)
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              qi_p(:,nyn+1,:) = qi_p(:,nyn,:)
              ni_p(:,nyn+1,:) = ni_p(:,nyn,:)
@@ -2687,5 +2690,5 @@
              nr_p(:,:,nxl-1) = nr_p(:,:,nxl)
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              qi_p(:,:,nxl-1) = qi_p(:,:,nxl)
              ni_p(:,:,nxl-1) = ni_p(:,:,nxl)
@@ -2700,5 +2703,5 @@
              nr_p(:,:,nxr+1) = nr_p(:,:,nxr)
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              qi_p(:,:,nxr+1) = qi_p(:,:,nxr)
              ni_p(:,:,nxr+1) = ni_p(:,:,nxr)
@@ -3345,6 +3348,6 @@
              READ ( 13 )  curvature_solution_effects_bulk
 
-          CASE ( 'microphysics_ice_extension' )
-             READ ( 13 )  microphysics_ice_extension
+          CASE ( 'microphysics_ice_phase' )
+             READ ( 13 )  microphysics_ice_phase
 
           CASE ( 'ice_crystal_sedimentation' )
@@ -3389,5 +3392,5 @@
        CALL rrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
        CALL rrd_mpi_io( 'start_ice_microphysics', start_ice_microphysics )
-       CALL rrd_mpi_io( 'microphysics_ice_extension', microphysics_ice_extension )
+       CALL rrd_mpi_io( 'microphysics_ice_phase', microphysics_ice_phase )
        CALL rrd_mpi_io( 'in_init', in_init )
        CALL rrd_mpi_io( 'ice_crystal_sedimentation', ice_crystal_sedimentation )
@@ -3642,5 +3645,5 @@
        ENDIF
 
-       IF ( microphysics_ice_extension )  THEN
+       IF ( microphysics_ice_phase )  THEN
 
           CALL rrd_mpi_io( 'ni', ni )
@@ -3724,6 +3727,6 @@
           WRITE ( 14 )  start_ice_microphysics
 
-          CALL wrd_write_string( 'microphysics_ice_extension' )
-          WRITE ( 14 )  microphysics_ice_extension
+          CALL wrd_write_string( 'microphysics_ice_phase' )
+          WRITE ( 14 )  microphysics_ice_phase
 
           CALL wrd_write_string( 'in_init' )
@@ -3750,5 +3753,5 @@
           CALL wrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
           CALL wrd_mpi_io( 'start_ice_microphysics', start_ice_microphysics )
-          CALL wrd_mpi_io( 'microphysics_ice_extension', microphysics_ice_extension )
+          CALL wrd_mpi_io( 'microphysics_ice_phase', microphysics_ice_phase )
           CALL wrd_mpi_io( 'in_init', in_init )
           CALL wrd_mpi_io( 'ice_crystal_sedimentation', ice_crystal_sedimentation )
@@ -3815,5 +3818,5 @@
           ENDIF
 
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
 
              CALL wrd_write_string( 'ni' )
@@ -3877,5 +3880,5 @@
              IF ( ALLOCATED( qr_av ) )  CALL wrd_mpi_io( 'qr_av', qr_av )
           ENDIF
-          IF ( microphysics_ice_extension )  THEN
+          IF ( microphysics_ice_phase )  THEN
              CALL wrd_mpi_io( 'ni', ni )
              IF ( ALLOCATED( ni_av ) )  CALL wrd_mpi_io( 'ni_av', ni_av )
@@ -4452,5 +4455,5 @@
 !--             Actual temperature, t_l is calculated directly before
 !--             in supersaturation
-                IF ( microphysics_ice_extension ) THEN
+                IF ( microphysics_ice_phase ) THEN
                    temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
                 ELSE
@@ -4539,5 +4542,5 @@
 !--       Actual temperature, t_l is calculated directly before
 !--       in supersaturation
-          IF ( microphysics_ice_extension ) THEN
+          IF ( microphysics_ice_phase ) THEN
              temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
           ELSE
@@ -6551,5 +6554,5 @@
        q_s   = q_s * ( 1.0_wp + alpha * q(k,j,i) ) / ( 1.0_wp + alpha * q_s )
 
-       IF ( .NOT. microphysics_ice_extension ) THEN
+       IF ( .NOT. microphysics_ice_phase ) THEN
           IF ( microphysics_seifert ) THEN
              sat = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
@@ -6633,5 +6636,5 @@
 !
 !--             Compute the liquid water content
-                IF ( .NOT. microphysics_ice_extension ) THEN
+                IF ( .NOT. microphysics_ice_phase ) THEN
                    IF ( microphysics_seifert  .AND. .NOT.                      &
                         microphysics_morrison )  THEN
Index: palm/trunk/SOURCE/compute_vpt.f90
===================================================================
--- palm/trunk/SOURCE/compute_vpt.f90	(revision 4520)
+++ palm/trunk/SOURCE/compute_vpt.f90	(revision 4521)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
 ! 
@@ -59,5 +62,5 @@
 
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, microphysics_ice_extension
+        ONLY:  bulk_cloud_model, microphysics_ice_phase
 
     IMPLICIT NONE
@@ -67,10 +70,10 @@
     IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
        vpt = pt * ( 1.0_wp + 0.61_wp * q )
-    ELSEIF ( bulk_cloud_model  .AND.  .NOT. microphysics_ice_extension )  THEN
+    ELSEIF ( bulk_cloud_model  .AND.  .NOT. microphysics_ice_phase )  THEN
        DO  k = nzb, nzt+1
               vpt(k,:,:) = ( pt(k,:,:) + d_exner(k) * lv_d_cp * ql(k,:,:) ) *  &
                        ( 1.0_wp + 0.61_wp * q(k,:,:) - 1.61_wp *  ql(k,:,:)  )
        ENDDO
-    ELSEIF ( bulk_cloud_model  .AND.  microphysics_ice_extension ) THEN
+    ELSEIF ( bulk_cloud_model  .AND.  microphysics_ice_phase ) THEN
        DO  k = nzb, nzt+1
           vpt(k,:,:) = ( pt(k,:,:) + d_exner(k) * lv_d_cp * ql(k,:,:)   +      &
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4520)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4521)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
 ! 
@@ -97,5 +100,5 @@
     USE bulk_cloud_model_mod,                                                  &
         ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert,   &
-              microphysics_ice_extension
+              microphysics_ice_phase
 
     USE chem_modules,                                                          &
@@ -1418,5 +1421,5 @@
                                                                 flag
                          ENDIF
-                         IF ( microphysics_ice_extension )  THEN
+                         IF ( microphysics_ice_phase )  THEN
                             sums_l(k,124,tn) = sums_l(k,124,tn) + ni(k,j,i) *  &
                                                                 rmask(j,i,sr) *&
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 4520)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 4521)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
 ! 
@@ -62,5 +65,5 @@
     USE bulk_cloud_model_mod,                                                  &
         ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert,   &
-              microphysics_ice_extension
+              microphysics_ice_phase
 
     USE control_parameters,                                                    &
@@ -277,7 +280,7 @@
                         '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
-                 ELSEIF ( .NOT. microphysics_ice_extension ) THEN
+                 ELSEIF ( .NOT. microphysics_ice_phase ) THEN
                    message_string = 'output of "' // TRIM( var ) // '" ' //    &
-                         'requires  microphysics_ice_extension = .TRUE.'
+                         'requires  microphysics_ice_phase = .TRUE.'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -355,7 +358,7 @@
                             'requires bulk_cloud_model = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-                ELSEIF ( .NOT. microphysics_ice_extension ) THEN
+                ELSEIF ( .NOT. microphysics_ice_phase ) THEN
                    message_string = 'output of "' // TRIM( var ) // '" ' //    &
-                            'requires microphysics_ice_extension = .TRUE.'
+                            'requires microphysics_ice_phase = .TRUE.'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4520)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4521)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
 ! 
@@ -479,5 +482,5 @@
     LOGICAL ::  surf_microphysics_morrison = .FALSE.   !< use 2-moment Morrison (add. prog. eq. for nc and qc)
     LOGICAL ::  surf_microphysics_seifert = .FALSE.    !< use 2-moment Seifert and Beheng scheme
-    LOGICAL ::  surf_microphysics_ice_extension = .FALSE. !< use 2-moment Seifert and Beheng scheme
+    LOGICAL ::  surf_microphysics_ice_phase = .FALSE. !< use 2-moment Seifert and Beheng scheme
 
 
@@ -535,5 +538,5 @@
            surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v, surf_type,      &
            vertical_surfaces_exist, surf_bulk_cloud_model, surf_microphysics_morrison,             &
-           surf_microphysics_seifert, surf_microphysics_ice_extension
+           surf_microphysics_seifert, surf_microphysics_ice_phase
 !
 !-- Public subroutines and functions
@@ -1315,5 +1318,5 @@
 !
 !--
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           DEALLOCATE ( surfaces%qis )
           DEALLOCATE ( surfaces%nis )
@@ -1452,5 +1455,5 @@
 !
 !--
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           ALLOCATE ( surfaces%qis(1:surfaces%ns)   )
           ALLOCATE ( surfaces%nis(1:surfaces%ns)   )
@@ -1611,5 +1614,5 @@
 !
 !--
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           DEALLOCATE ( surfaces%qisws )
           DEALLOCATE ( surfaces%nisws )
@@ -1690,5 +1693,5 @@
 !
 !--
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           ALLOCATE ( surfaces%qisws(1:surfaces%ns) )
           ALLOCATE ( surfaces%nisws(1:surfaces%ns) )
@@ -1875,5 +1878,5 @@
        ENDIF
 
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           DEALLOCATE ( surfaces%qis )
           DEALLOCATE ( surfaces%nis )
@@ -2008,5 +2011,5 @@
        ENDIF
 
-       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
           ALLOCATE ( surfaces%qis(1:surfaces%ns)   )
           ALLOCATE ( surfaces%nis(1:surfaces%ns)   )
@@ -2657,5 +2660,5 @@
                 ENDIF
 
-                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
                    surf%qis(num_h) = 0.0_wp
                    surf%nis(num_h) = 0.0_wp
@@ -2838,5 +2841,5 @@
                    surf%qrsws(num_h) = 0.0_wp
                 ENDIF
-                IF ( surf_bulk_cloud_model  .AND.  surf_microphysics_ice_extension ) THEN
+                IF ( surf_bulk_cloud_model  .AND.  surf_microphysics_ice_phase ) THEN
                    surf%nisws(num_h) = 0.0_wp
                    surf%qisws(num_h) = 0.0_wp
@@ -2982,5 +2985,5 @@
                    surf%nrsws(num_v) = 0.0_wp
                 ENDIF
-                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_phase)  THEN
                    surf%qis(num_v) = 0.0_wp
                    surf%nis(num_v) = 0.0_wp
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4520)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4521)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Rename variable
+! 
+! 4511 2020-04-30 12:20:40Z raasch
 ! chemistry decycling replaced by explicit setting of lateral boundary conditions
 ! 
@@ -233,5 +236,5 @@
     USE bulk_cloud_model_mod,                                                                      &
         ONLY: bulk_cloud_model, calc_liquid_water_content, collision_turbulence,                   &
-              microphysics_ice_extension, microphysics_morrison, microphysics_seifert
+              microphysics_ice_phase, microphysics_morrison, microphysics_seifert
 
     USE calc_mean_profile_mod,                                                                     &
@@ -808,5 +811,5 @@
                 CALL exchange_horiz( nr_p, nbgp )
              ENDIF
-             IF ( bulk_cloud_model .AND. microphysics_ice_extension )  THEN
+             IF ( bulk_cloud_model .AND. microphysics_ice_phase )  THEN
                 CALL exchange_horiz( qi_p, nbgp )
                 CALL exchange_horiz( ni_p, nbgp )
@@ -907,5 +910,5 @@
                        CALL exchange_horiz( nr, nbgp )
                    ENDIF
-                   IF ( bulk_cloud_model  .AND.  microphysics_ice_extension )  THEN
+                   IF ( bulk_cloud_model  .AND.  microphysics_ice_phase )  THEN
                       CALL exchange_horiz( qi, nbgp )
                       CALL exchange_horiz( ni, nbgp )